Index: trunk/tests/AppTest.php
===================================================================
--- trunk/tests/AppTest.php	(revision 468)
+++ trunk/tests/AppTest.php	(revision 479)
@@ -94,5 +94,5 @@
     function test_dbquery()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $qid = $db->query("SELECT 2 + 2");
Index: trunk/tests/AuthSQLTest.php
===================================================================
--- trunk/tests/AuthSQLTest.php	(revision 468)
+++ trunk/tests/AuthSQLTest.php	(revision 479)
@@ -38,5 +38,5 @@
     function setUp()
     {
-	    require dirname(__FILE__) . '/_config.inc.php';
+        require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Auth_SQL.inc.php';
         $this->Auth_SQL = new Auth_SQL('testauth');
@@ -75,7 +75,7 @@
     function tearDown()
     {
-    	$db =& DB::getInstance();
-
-	    unset($this->Auth_SQL);
+        $db =& DB::getInstance();
+
+        unset($this->Auth_SQL);
         $db->query("DROP TABLE IF EXISTS test_user_tbl");
         $db->query("DROP TABLE IF EXISTS test_login_tbl");
@@ -163,5 +163,5 @@
     function test_blockaccount()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $this->Auth_SQL->login('testuser', 'testpass');
@@ -177,5 +177,5 @@
     function test_unblockaccount()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $db->query("
@@ -239,5 +239,5 @@
     function test_setpassword()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $this->Auth_SQL->setParam(array('encryption_type' => Auth_SQL::ENCRYPT_SHA1_HARDENED));
Index: trunk/tests/Auth_SQLTest.php
===================================================================
--- trunk/tests/Auth_SQLTest.php	(revision 468)
+++ trunk/tests/Auth_SQLTest.php	(revision 479)
@@ -42,5 +42,5 @@
     function setUp()
     {
-	    require dirname(__FILE__) . '/_config.inc.php';
+        require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Auth_SQL.inc.php';
         $this->Auth_SQL =& new Auth_SQL('testauth');
@@ -79,7 +79,7 @@
     function tearDown()
     {
-    	$db =& DB::getInstance();
-
-	    unset($this->Auth_SQL);
+        $db =& DB::getInstance();
+
+        unset($this->Auth_SQL);
         $db->query("DROP TABLE IF EXISTS test_user_tbl");
         $db->query("DROP TABLE IF EXISTS test_login_tbl");
@@ -163,5 +163,5 @@
     function test_blockaccount()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $this->Auth_SQL->login('testuser', 'testpass');
@@ -177,5 +177,5 @@
     function test_unblockaccount()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $db->query("
@@ -239,5 +239,5 @@
     function test_setpassword()
     {
-		$db =& DB::getInstance();
+        $db =& DB::getInstance();
 
         $this->Auth_SQL->setParam(array('encryption_type' => Auth_SQL::ENCRYPT_SHA1_HARDENED));
Index: trunk/tests/LockTest.php
===================================================================
--- trunk/tests/LockTest.php	(revision 468)
+++ trunk/tests/LockTest.php	(revision 479)
@@ -37,5 +37,5 @@
 
     function setUp()
-    {	
+    {   
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Lock.inc.php';
@@ -86,6 +86,6 @@
     function tearDown()
     {
-		$db =& DB::getInstance();
-	
+        $db =& DB::getInstance();
+    
         unset($this->Lock);
         unset($this->Auth_SQL);
Index: trunk/tests/VersionTest.php
===================================================================
--- trunk/tests/VersionTest.php	(revision 468)
+++ trunk/tests/VersionTest.php	(revision 479)
@@ -37,5 +37,5 @@
 
     function setUp()
-    {	
+    {   
         require dirname(__FILE__) . '/_config.inc.php';
         require_once '../lib/Version.inc.php';
@@ -83,6 +83,6 @@
     function tearDown()
     {
-		$db =& DB::getInstance();
-	
+        $db =& DB::getInstance();
+    
         unset($this->Version);
         unset($this->Auth_SQL);